import { _decorator } from "cc";
import GRoleBase from "../GRoleBase";
import GFSMBase from "../../fsm/GFSMBase";
import GFSMPVP from "../../fsm/PVP/GFSMPVP";
import GPVPMode, { GPVPModePlayerEnum } from "../../../PVP/GPVPMode";
import { GTactical } from "../../../entity/GTactical";
import { GFSMBattleAmin } from "../../fsm/base/GFSMBattle/GFSMBattleAmin";
import { JNFrameInfo } from "../../../../../../extensions/ngame/assets/ngame/sync/frame/JNSyncFrame";
import { Vec2 } from "cc";
import { v2 } from "cc";
import { ProgressBar } from "cc";
const { ccclass, property } = _decorator;

export interface GDemoMessage{
    isAttack?:boolean;
    isRun?:boolean;
}

//PVP 角色
@ccclass('GRolePVPEntity')
export default class GRolePVPEntity extends GRoleBase<GDemoMessage>{

    //所属阵容
    _ones:GPVPModePlayerEnum;
    get ones():GPVPModePlayerEnum{
        return this._ones;
    }
    set ones(value:GPVPModePlayerEnum){
        //如果是敌方则设置镜像
        if(value == GPVPModePlayerEnum.ENEMY){
            this.isMirror = true;
        }else{
            this.isMirror = false;
        }
        this._ones = value;
    }

    @property(ProgressBar)
    bloodVolume:ProgressBar;

    onSyncLoad(){
        super.onSyncLoad();
    }

    getClassName():string{return "GDemoMessage"}
    onSyncUpdate(dt: number,frame:JNFrameInfo, input?: GDemoMessage) { 
        super.onSyncUpdate(dt,frame,input);
        if(input){
            if(Object.prototype.hasOwnProperty.call(input,"isAttack")){
                this.fsmAnim.isAttack = input.isAttack;
            }
            if(Object.prototype.hasOwnProperty.call(input,"isRun")){
                this.fsmAnim.isMove = input.isRun;
            }
        }

        //更新血量显示
        this.bloodVolume.progress =  this.blood / this.fullBlood;
    }
    

    get mode():GPVPMode{
        return super.mode as GPVPMode;
    }
    set mode(value:GPVPMode){
        this._mode = value;
    }

    protected fsmCreate(): GFSMPVP {
        return new GFSMPVP(this);
    }
    protected fsmAnimCreate(): GFSMBattleAmin {
        return new GFSMBattleAmin(this.spine);
    }

    //添加死亡销毁
    onHit(){
        super.onHit();
        if(this.isDie){
            //销毁数据
            this.mode.killRole(this);
            this.node.removeFromParent();
        }
    }
    
}

